#include "StringHash.h"
#include "StringArray.h"

int main(int argc, char ** argv)
   {
   if (argc < 2)
      {
      printf("Filters a file according to keyword in the first column\n\n"
             "   Usage: filter valid_keys < file > filtered-file\n\n");
      exit(-1);
      }

   StringHash key;
   key.ReadLinesFromFile(argv[1]);

   String input;
   StringArray tokens;

   while (!feof(stdin))
      {
      tokens.ReplaceTokens(input.ReadLine());

      if (tokens.Length() > 0 && key.Find(tokens[0]) >= 0)
         printf("%s\n", (const char *) input);
      }
   }
